; Inno Setup Script
[Setup]
MinVersion=4.1.1998,4.0
AppName=Rhino PieMenu / Marking Menus
;AppId={90A7FB06-85A5-4A2A-9031-A5B15EC42344}
CreateUninstallRegKey=true
UsePreviousAppDir=false
UsePreviousGroup=false
AppVersion=1.40
AppVerName=Rhino PieMenu 1.02
AppCopyright=Copyright E-CNC, 2001-2004
WizardStyle=modern
UninstallStyle=modern
WindowShowCaption=true
WindowStartMaximized=true
WindowVisible=false
WindowResizable=true
UninstallLogMode=new
DirExistsWarning=auto
UninstallFilesDir={app}
DisableDirPage=false
DisableStartupPrompt=true
CreateAppDir=true
DisableProgramGroupPage=true
Uninstallable=true
DefaultDirName={reg:HKLM\SOFTWARE\McNeel\Rhinoceros\3.0\{reg:HKLM\SOFTWARE\McNeel\Rhinoceros\3.0\,MostRecent}\Install\,InstallPath}\Plug-Ins\RHPieMenu
DefaultGroupName=Rhino PieMenu
AlwaysShowDirOnReadyPage=true
LicenseFile=D:\0_MIJO\vb\rhpiemenu\install\rhpiemenu_license.rtf
;InfoBeforeFile=D:\rhinodev\KUS\E-CNC_Acknowledgements.txt
InfoAfterFile=D:\0_MIJO\vb\rhpiemenu\install\E-CNC_readme.rtf
OutputBaseFilename=setup_RHPieMenu
FlatComponentsList=true
ShowComponentSizes=true
SourceDir=D:\0_MIJO\vb\rhpiemenu\install\
OutputDir=D:\0_MIJO\vb\rhpiemenu\install\
UninstallDisplayIcon={app}\uninstall.ico
UninstallDisplayName=Uninstall RHPieMenu Rhino3 Plug-In
ShowTasksTreeLines=false
AppPublisher=E-CNC, Inc.
AppPublisherURL=http://www.e-cnc.com
AppSupportURL=http://www.rhino3d.e-cnc.com
AppUpdatesURL=http://www.rhino3d.e-cnc.com
DisableFinishedPage=true
RestartIfNeededByRun=false
WizardImageBackColor=clBlack
DisableReadyMemo=true
DisableReadyPage=true
AlwaysShowGroupOnReadyPage=true
Compression=zip/9
WizardImageFile=D:\0_MIJO\vb\rhpiemenu\install\rhpiemenu_install.bmp
ShowLanguageDialog=yes
WizardImageStretch=true
SolidCompression=true
VersionInfoVersion=0.1
VersionInfoCompany=E-CNC
VersionInfoDescription=RHPieMenu Rhino3 Plug-In
[Files]
Source: RHPieMenu.exe; DestDir: {app}\; DestName: RHPieMenu.exe; Flags: confirmoverwrite comparetimestamp; MinVersion: 4.1.1998,4.0.1381
Source: RHPieMenu.chm; DestDir: {app}\; Flags: confirmoverwrite overwritereadonly; DestName: rhpiemenu.chm
Source: getrh.dll; Flags: dontcopy
[Icons]
Name: {group}\Uninstall RHPieMenu Rhino3 Plug-In; Filename: {uninstallexe}
Name: {group}\RHPieMenu Rhino3 Plug-In HELP; Filename: {app}\rhpiemenu.chm; IconFilename: {app}\RHPieMenu.chm

[INI]

[Registry]
Root: HKCU; SubKey: Software\McNeel\Rhinoceros\3.0\Scheme: Default\Options\AliasList; ValueName: RHPieMenuCHM; ValueType: string; ValueData: "NoEcho _Run ""{app}\RHPieMenu.chm"""; Flags: uninsdeletevalue
Root: HKCU; SubKey: Software\McNeel\Rhinoceros\3.0\Scheme: Default\Options\AliasList; ValueName: RHPieMenu; ValueType: string; ValueData: "NoEcho _Run ""{app}\RHPieMenu.exe"""; Flags: uninsdeletevalue

[UninstallDelete]
Name: {app}\uninstall.ico; Type: files
Name: {app}\RHPieMenu.exe; Type: files
Name: {app}\rhpiemenu.chm; Type: files
Name: {app}\rhpiemenu.GID; Type: files
Name: {app}\rhpiemenu; Type: filesandordirs

[InstallDelete]

[Run]
;Filename: {reg:HKLM\SOFTWARE\McNeel\Rhinoceros\3.0\{reg:HKLM\SOFTWARE\McNeel\Rhinoceros\3.0\,MostRecent}\Install\,Path}Rhino3.exe; Flags: waituntilidle runhidden runminimized; StatusMsg: Starting Rhino3D - WAIT ......; Parameters: /nosplash
[UninstallRun]

[LangOptions]
LanguageName=English
LanguageID=$0409

[_ISTool]
EnableISX=true

[Messages]
FinishedLabel=Setup has finished installing [name] Plug-In on your computer. The application may be launched trough the Rhino's alias RHPieMenu by typing in Rhino command prompt.
WelcomeLabel2=This will install [name/ver] Rhino3D Plug-In on your computer.%n%nIt is recommended that you close all other applications before continuing.
UninstalledMost=%1 uninstall complete.
[Languages]
Name: default; MessagesFile: compiler:default.isl

[Code]
//importing a custom DLL function
function GetRhinoProc(hWnd: Integer):Integer;
external 'GetRhinoProc@files:getrh.dll stdcall';
//winAPI messagebox
function MessageBox(hWnd: Integer; lpText, lpCaption: String; uType: Cardinal): Integer;
external 'MessageBoxA@user32.dll stdcall';

const MB_ICONEXCLAMATION = 48;

function InitializeSetup(): Boolean;
var rhino: Integer;
var hWnd: Integer;
begin
	hWnd := StrToInt(ExpandConstant('{wizardhwnd}'));
  try
    rhino := GetRhinoProc(hWnd);
  except
		MessageBox(hWnd, 'Cannot find getrh.dll file. Please close all the running Rhino instances to continue with the RHPieMenu Setup','RHPieMenu Rhino Plug-In' ,MB_ICONEXCLAMATION );
  end;

	if (rhino >0) then begin
		MessageBox(hWnd, 'Setup has detected [ '+ IntToStr(rhino)+' ] instance of Rhino running!'+ #13#13+'Please close all the running Rhino instances and run setup again.', 'RHPieMenu Rhino Plug-In Install', MB_ICONEXCLAMATION );
		Exit;
	end else begin
		Result := True;
	end;
end;

function GetCountOTF():Boolean;
var VNum0:String;
var mijo0:Integer;
var new_mijo0:String;
begin
    RegQueryStringValue(HKCU,'Software\McNeel\Rhinoceros\3.0\Scheme: Default\Open toolbar files','Count',VNum0);
    mijo0:= StrToInt(VNum0);
    mijo0:= mijo0 + 1;
    new_mijo0 := IntToStr(mijo0);
    RegWriteStringValue (HKCU,'Software\McNeel\Rhinoceros\3.0\Scheme: Default\Open toolbar files', 'Count',new_mijo0 );
    Result := True;
end;

function GetCountRTM():Boolean;
var VNum1:String;
var mijo1:Integer;
var new_mijo1:String;
begin
    RegQueryStringValue(HKCU,'Software\McNeel\Rhinoceros\3.0\Scheme: Default\RhinoToolBarManager','Count',VNum1);
    mijo1:= StrToInt(VNum1);
    mijo1:= mijo1 + 1;
    new_mijo1 := IntToStr(mijo1);
    RegWriteStringValue (HKCU,'Software\McNeel\Rhinoceros\3.0\Scheme: Default\RhinoToolBarManager', 'Count',new_mijo1 );
    Result := True;
end;
//rhino tool manager registry entry
function GetNewCountRTM(S:String):String;
var VNum2:String;
var mijo2:Integer;
var new_mijo2:String;
begin
      RegQueryStringValue(HKCU,'Software\McNeel\Rhinoceros\3.0\Scheme: Default\RhinoToolBarManager','Count',VNum2);
    mijo2:= StrToInt(VNum2);
    mijo2:= mijo2 - 1;
    new_mijo2 := IntToStr(mijo2);
    Result := new_mijo2;
end;
//rhino open toolboxes registry entries
function GetNewCountOTF(S:String):String;
var VNum3:String;
var mijo3:Integer;
var new_mijo3:String;
begin
      RegQueryStringValue(HKCU,'Software\McNeel\Rhinoceros\3.0\Scheme: Default\Open toolbar files','Count',VNum3);
    mijo3:= StrToInt(VNum3);
    mijo3:= mijo3 - 1;
    new_mijo3 := IntToStr(mijo3);
    Result := new_mijo3;
end;

procedure CurPageChanged(CurPage: Integer);
//procedure CurStepChanged(CurStep: Integer);
var StartInstall: Boolean;
begin
   if CurPage = wpInstalling then
    StartInstall := GetCountRTM();

  if CurPage = wpInstalling then
    StartInstall := GetCountOTF();
end;
